/* fckez.js

{{IS_NOTE
	Purpose:
		
	Description:
		
	History:
		Tue Dec 27 10:25:06     2005, Created by tomyeh@potix.com
}}IS_NOTE

Copyright (C) 2005 Potix Corporation. All Rights Reserved.

{{IS_RIGHT
}}IS_RIGHT
*/
zkFCKeditor = {};

function FCKeditor_OnComplete(fed) {
  fed.Events.AttachEvent("OnBlur", zkFCKeditor.onblur);
}

/** Init */
zkFCKeditor.init = function (ed) {
	FCKeditorAPI = __FCKeditorNS = null;
		//Note: we have to clean up, because iframe (FCKeditor lives)
		//might be dropped and another instance might be created
	var ifr = $e(ed.id + "!ed___Frame");
	ifr.src = getZKAttr(ed, "src");
		//Note: HTML is rendered first (before fckez.js), so we have to delay
		//until now

	if (zkau.addOnSend) { //back compatible
		//Bug 1510539: onblur is checked periodically by FCKeditor so it might be too late.
		var meta = zkau.getMeta(ed);
		if (meta) {
			zkau.removeOnSend(meta.onsend); //just in case
		} else {
			meta = {
				onsend: function() {
					if (FCKeditorAPI) {
						var fed = FCKeditorAPI.GetInstance(ed.id + "!ed");
						if (fed) zkFCKeditor.onblur(fed, true);
					}
				}
			};		
			zkau.setMeta(ed, meta);
		}
		zkau.addOnSend(meta.onsend);
	}
};
zkFCKeditor.cleanup = function (ed) {
	var meta = zkau.getMeta(ed);
	if (meta) zkau.removeOnSend(meta.onsend);
};

/** Called by the server to set the attribute. */
zkFCKeditor.setAttr = function (ed, name, value) {
	var ifr = $e(ed.id + "!ed___Frame");
	var fed = FCKeditorAPI.GetInstance(ed.id + "!ed");
	if (ifr) {
		switch (name) {
		case "width":
			ifr.width = value;
			return true;
		case "height":
			ifr.height = value;
			return true;
		case "value":
			if (fed) fed.SetHTML(value);
			return true;
		}
	}
	return false;
};

/** Called by the server to remove the attribute. */
zkFCKeditor.rmAttr = function (ed, name) {
	var ifr = $e(ed.id + "!ed___Frame");
	var fed = FCKeditorAPI.GetInstance(ed.id + "!ed");
	if (ifr) {
		switch (name) {
		case "width":
			ifr.width = "";
			return true;
		case "height":
			ifr.height = "";
			return true;
		case "value":
			if (fed) fed.SetHTML("");
			return true;
		}
	}
	return false;
};
zkFCKeditor.onblur = function (fed, ahead) {
	if (fed.IsDirty()) {
		var uuid = $uuid(fed.Name);
		var comp = $e(uuid);
		var val = fed.GetXHTML();
		var evt = {uuid: uuid, cmd: "onChange", data: [val]};
		if (ahead) zkau.sendAhead(evt);
		else zkau.send(evt, zkau.asapTimeout(comp, "onChange"));
		fed.ResetIsDirty();
	}
};
